diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/merge/DefaultMergeStrategyTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/merge/DefaultMergeStrategyTest.java
index a9a253cdb7..2428427d94 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/merge/DefaultMergeStrategyTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/merge/DefaultMergeStrategyTest.java
@@ -36,13 +36,13 @@ import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
 import eu.etaxonomy.cdm.model.location.Point;
 import eu.etaxonomy.cdm.model.location.ReferenceSystem;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.NameRelationship;
 import eu.etaxonomy.cdm.model.name.NameRelationshipType;
 import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignationStatus;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
@@ -52,7 +52,6 @@ import eu.etaxonomy.cdm.strategy.cache.reference.INomenclaturalReferenceCacheStr
 /**
  * @author a.mueller
  * @created 03.08.2009
- * @version 1.0
  */
 public class DefaultMergeStrategyTest {
 	@SuppressWarnings("unused")
@@ -332,7 +331,7 @@ public class DefaultMergeStrategyTest {
 		
 		//name relations
 		botName2.addBasionym(botName3, book1, "p.22", null);
-		Specimen specimen1 = Specimen.NewInstance();
+		DerivedUnit specimen1 = DerivedUnit.NewPreservedSpecimenInstance();
 		botName2.addSpecimenTypeDesignation(specimen1, SpecimenTypeDesignationStatus.HOLOTYPE(), book2, "p.56", "originalNameString", false, true);
 		
 		//descriptions
@@ -412,7 +411,7 @@ public class DefaultMergeStrategyTest {
 		team1.setTitleCache("Team1", true);
 		team1.setNomenclaturalTitle("T.1");
 		String street1 = "Strasse1";
-		team1.setContact(Contact.NewInstance(street1, "12345", "Berlin", WaterbodyOrCountry.ARGENTINAARGENTINEREPUBLIC(),"pobox" , "Region", "a@b.de", "f12345", "+49-30-123456", "www.abc.de", Point.NewInstance(2.4, 3.2, ReferenceSystem.WGS84(), 3)));
+		team1.setContact(Contact.NewInstance(street1, "12345", "Berlin", Country.ARGENTINAARGENTINEREPUBLIC(),"pobox" , "Region", "a@b.de", "f12345", "+49-30-123456", "www.abc.de", Point.NewInstance(2.4, 3.2, ReferenceSystem.WGS84(), 3)));
 		team2.setContact(Contact.NewInstance("Street2", null, "London", null, null, null, null, "874599873", null, null, null));
 		String street3 = "Street3";
 		team2.addAddress(street3, null, null, null, null, null, Point.NewInstance(1.1, 2.2, null, 4));
@@ -451,7 +450,7 @@ public class DefaultMergeStrategyTest {
 			if (street3.equals(address.getStreet())){
 				street3Exists = true;
 			}
-			if (WaterbodyOrCountry.ARGENTINAARGENTINEREPUBLIC() == address.getCountry()){
+			if (Country.ARGENTINAARGENTINEREPUBLIC() == address.getCountry()){
 				country1Exists = true;
 			}
 		}
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplTest.java
index d01aa626c6..6bb944d957 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplTest.java
@@ -51,7 +51,7 @@ import eu.etaxonomy.cdm.model.reference.ReferenceType;
  *
  */
 public class NonViralNameParserImplTest {
-	private static final NomenclaturalCode ICBN = NomenclaturalCode.ICBN;
+	private static final NomenclaturalCode ICBN = NomenclaturalCode.ICNAFP;
 	private static final NomenclaturalCode ICZN = NomenclaturalCode.ICZN;
 
 	private static final Logger logger = Logger.getLogger(NonViralNameParserImplTest.class);
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/TimePeriodParserTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/TimePeriodParserTest.java
new file mode 100644
index 0000000000..2b7932bf69
--- /dev/null
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/strategy/parser/TimePeriodParserTest.java
@@ -0,0 +1,200 @@
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/ 
+
+package eu.etaxonomy.cdm.strategy.parser;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertNull;
+import static org.junit.Assert.assertTrue;
+import org.junit.Assert;
+
+import org.apache.log4j.Logger;
+import org.joda.time.DateTimeFieldType;
+import org.joda.time.Partial;
+import org.junit.After;
+import org.junit.AfterClass;
+import org.junit.Before;
+import org.junit.BeforeClass;
+import org.junit.Test;
+
+import eu.etaxonomy.cdm.model.common.TimePeriod;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
+
+/**
+ * @author a.mueller
+ *
+ */
+public class TimePeriodParserTest {
+	private static final Logger logger = Logger.getLogger(TimePeriodParserTest.class);
+	
+	private TimePeriod onlyStartYear;
+	private TimePeriod onlyEndYear;
+	private TimePeriod startAndEndYear;
+	private TimePeriod noStartAndEndYear;
+	
+	
+	/**
+	 * @throws java.lang.Exception
+	 */
+	@BeforeClass
+	public static void setUpBeforeClass() throws Exception {
+	}
+
+	/**
+	 * @throws java.lang.Exception
+	 */
+	@AfterClass
+	public static void tearDownAfterClass() throws Exception {
+	}
+
+	/**
+	 * @throws java.lang.Exception
+	 */
+	@Before
+	public void setUp() throws Exception {
+		onlyStartYear = TimePeriod.NewInstance(1922);
+		onlyEndYear = TimePeriod.NewInstance(null, 1857);;
+		startAndEndYear = TimePeriod.NewInstance(1931, 1957);
+		Integer start = null;
+		Integer end = null;
+		noStartAndEndYear = TimePeriod.NewInstance(start, end);;
+	}
+
+	/**
+	 * @throws java.lang.Exception
+	 */
+	@After
+	public void tearDown() throws Exception {
+	}
+
+	
+//************************ TESTS ******************************************		
+	
+
+	@Test
+	public void testParseSingleDateString() {
+		String strDate = "1756";
+		Partial date = TimePeriodParser.parseSingleDate(strDate);
+		assertNotNull(date);
+		Assert.assertEquals(Integer.parseInt(strDate), date.get(DateTimeFieldType.year()));
+		try {
+			date.get(DateTimeFieldType.monthOfYear());
+			assertFalse(true); //should not be reached
+		} catch (Exception e) {
+			assertTrue(e instanceof IllegalArgumentException);
+		}
+		try {
+			date.get(DateTimeFieldType.dayOfMonth());
+			assertFalse(true); //should not be reached
+		} catch (Exception e) {
+			assertTrue(e instanceof IllegalArgumentException);
+		}
+		//to be continued
+	}
+	
+	
+	/**
+	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#parseString(java.lang.String)}.
+	 */
+	@Test
+	public void testParseStringString() {
+		String strTimePeriod = "1756";
+		TimePeriod tp1 = TimePeriodParser.parseString(strTimePeriod);
+		assertNotNull(tp1);
+		Assert.assertEquals(strTimePeriod, tp1.getYear());
+		Assert.assertEquals(strTimePeriod, String.valueOf(tp1.getStartYear()));
+		assertNull(tp1.getEnd());
+		assertNull(tp1.getStartMonth());
+		strTimePeriod = "1756-88";
+		tp1 = TimePeriodParser.parseString(strTimePeriod);
+		assertNotNull(tp1);
+		Assert.assertEquals("1756-1788", tp1.getYear());
+		Assert.assertEquals("1756", String.valueOf(tp1.getStartYear()));
+		Assert.assertEquals("1788", String.valueOf(tp1.getEndYear()));
+		assertNull(tp1.getEndMonth());
+		assertNull(tp1.getStartMonth());
+		//unparsable
+		String strUnparsablePeriod = "wef 1809-78";
+		TimePeriod tpUnparsable = TimePeriodParser.parseString(strUnparsablePeriod);
+		assertNotNull(tpUnparsable);
+		Assert.assertEquals(strUnparsablePeriod, tpUnparsable.getFreeText());
+		
+		//"1806"[1807]
+		String strCorrectedPeriod = "\"1806\"[1807]";
+		TimePeriod tpcorrected = TimePeriodParser.parseString(strCorrectedPeriod);
+		assertNotNull(tpcorrected);
+		Assert.assertEquals(strCorrectedPeriod, tpcorrected.getFreeText());
+		Assert.assertEquals("1807", tpcorrected.getYear());
+		
+		
+		//fl. 1806
+		String strFlPeriod = "fl.  1806?";
+		TimePeriod tpFl = TimePeriodParser.parseString(strFlPeriod);
+		assertNotNull(tpFl);
+		Assert.assertEquals(strFlPeriod, tpFl.getFreeText());
+		Assert.assertEquals("1806", tpFl.getYear());
+		
+		String strCPeriod = "c.  1806-1810";
+		TimePeriod tpC = TimePeriodParser.parseString(strCPeriod);
+		assertNotNull(tpC);
+		Assert.assertEquals(strCPeriod, tpC.getFreeText());
+		Assert.assertEquals(Integer.valueOf(1806), tpC.getStartYear());
+		Assert.assertEquals(Integer.valueOf(1810), tpC.getEndYear());
+		Assert.assertEquals("1806-1810", tpC.getYear());
+		
+		//1.1.2011
+		String strDotDate = "1.2.2011";
+		TimePeriod tp = TimePeriodParser.parseString(strDotDate);
+		assertNotNull(tp);
+		Assert.assertEquals(strDotDate, tp.toString());
+		Assert.assertEquals("2011", tp.getYear());
+		Assert.assertEquals(Integer.valueOf(2), tp.getStartMonth());
+		Assert.assertEquals(Integer.valueOf(1), tp.getStartDay());
+		
+		strDotDate = "31.03.2012";
+		tp = TimePeriodParser.parseString(strDotDate);
+		assertNotNull(tp);
+		Assert.assertEquals("31.3.2012", tp.toString());
+		Assert.assertEquals("2012", tp.getYear());
+		Assert.assertEquals(Integer.valueOf(3), tp.getStartMonth());
+		Assert.assertEquals(Integer.valueOf(31), tp.getStartDay());
+		
+		strDotDate = "00.04.2013";
+		tp = TimePeriodParser.parseString(strDotDate);
+		assertNotNull(tp);
+		Assert.assertEquals("4.2013", tp.toString());
+		Assert.assertEquals("2013", tp.getYear());
+		Assert.assertEquals(Integer.valueOf(4), tp.getStartMonth());
+		Assert.assertEquals(null, tp.getStartDay());
+		
+		strDotDate = "13.00.2014";
+		tp = TimePeriodParser.parseString(strDotDate);
+		assertNotNull(tp);
+		Assert.assertEquals("13.xx.2014", tp.toString());
+		Assert.assertEquals("2014", tp.getYear());
+		Assert.assertEquals(null, tp.getStartMonth());
+		Assert.assertEquals(Integer.valueOf(13), tp.getStartDay());
+		
+		strDotDate = "31.12.2015 - 02.01.2016";
+		tp = TimePeriodParser.parseString(strDotDate);
+		assertNotNull(tp);
+		Assert.assertEquals("31.12.2015-2.1.2016", tp.toString());
+		Assert.assertEquals("2015-2016", tp.getYear());
+		Assert.assertEquals(Integer.valueOf(2015), tp.getStartYear());
+		Assert.assertEquals(Integer.valueOf(12), tp.getStartMonth());
+		Assert.assertEquals(Integer.valueOf(31), tp.getStartDay());
+		Assert.assertEquals(Integer.valueOf(2016), tp.getEndYear());
+		Assert.assertEquals(Integer.valueOf(1), tp.getEndMonth());
+		Assert.assertEquals(Integer.valueOf(2), tp.getEndDay());		
+	}
+	
+	
+}
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/function/TestSpecimen.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/function/TestSpecimen.java
index 898450ba28..cb80bad1a3 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/function/TestSpecimen.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/function/TestSpecimen.java
@@ -25,7 +25,7 @@ import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.LanguageString;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.media.MediaRepresentation;
 import eu.etaxonomy.cdm.model.media.MediaRepresentationPart;
@@ -33,10 +33,10 @@ import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.occurrence.Collection;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
+import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
 import eu.etaxonomy.cdm.model.occurrence.GatheringEvent;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
@@ -87,8 +87,8 @@ public class TestSpecimen {
 		
 		logger.info("Create locality");
 		NamedArea namedArea = NamedArea.NewInstance();
-		WaterbodyOrCountry country = WaterbodyOrCountry.ARGENTINAARGENTINEREPUBLIC();
-		namedArea.addWaterbodyOrCountry(country);
+		Country country = Country.ARGENTINAARGENTINEREPUBLIC();
+		namedArea.addCountry(country);
 		namedArea.setType(NamedAreaType.ADMINISTRATION_AREA());
 		// XX
 		
@@ -99,7 +99,7 @@ public class TestSpecimen {
 		
 		
 		logger.info("Create new specimen ...");
-		Specimen specimen = Specimen.NewInstance();
+		DerivedUnit specimen = DerivedUnit.NewPreservedSpecimenInstance();
 		specimen.setCatalogNumber("JE 00004506");
 		specimen.setStoredUnder(botanicalName);   //??
 		specimen.setCollection(collection);
@@ -121,19 +121,18 @@ public class TestSpecimen {
 		
 		MediaRepresentationPart mediaRepresentationPart = MediaRepresentationPart.NewInstance(uri, size);
 		mediaRepresentation.addRepresentationPart(mediaRepresentationPart);
-		specimen.addMedia(media);
+//		specimen.addMedia(media);    #3597
 
 		//Original ID
-		IdentifiableSource source = IdentifiableSource.NewInstance();
 		String id = "22";
-		source.setIdInSource(id);
+		IdentifiableSource source = IdentifiableSource.NewDataImportInstance(id);
 		specimen.addSource(source);
 		
-		FieldObservation fieldObservation = FieldObservation.NewInstance();
+		FieldUnit fieldUnit = FieldUnit.NewInstance();
 		DerivationEvent derivationEvent = DerivationEvent.NewInstance(DerivationEventType.GATHERING_IN_SITU());
 		derivationEvent.addDerivative(specimen);
-		fieldObservation.addDerivationEvent(derivationEvent);
-		fieldObservation.setGatheringEvent(gatheringEvent);
+		fieldUnit.addDerivationEvent(derivationEvent);
+		fieldUnit.setGatheringEvent(gatheringEvent);
 		
 		
 		//type information
@@ -146,10 +145,10 @@ public class TestSpecimen {
 		Set<SpecimenOrObservationBase> originals = dEvent.getOriginals();
 		logger.warn("Originals: " + originals);
 		for (SpecimenOrObservationBase original : originals){
-			if (original instanceof FieldObservation){
-				FieldObservation fieldObservation2 = (FieldObservation)original;
-				logger.warn("FieldObservation: " + fieldObservation2);
-				GatheringEvent gatheringEvent2= fieldObservation2.getGatheringEvent();
+			if (original instanceof FieldUnit){
+				FieldUnit fieldUnit2 = (FieldUnit)original;
+				logger.warn("FieldUnit: " + fieldUnit2);
+				GatheringEvent gatheringEvent2= fieldUnit2.getGatheringEvent();
 				logger.warn("GatheringEvent: " + gatheringEvent2);
 				AgentBase<?> gatherer2 = gatheringEvent2.getCollector();
 				logger.warn("Gatherer: "+  gatherer2);
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/suite/CdmTestSuite.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/suite/CdmTestSuite.java
index 94fc264b48..6624453356 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/suite/CdmTestSuite.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/test/suite/CdmTestSuite.java
@@ -9,18 +9,21 @@
  
 package eu.etaxonomy.cdm.test.suite;
 
+import org.apache.log4j.Logger;
 import org.junit.runner.RunWith;
 import org.junit.runners.Suite;
-import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.aspectj.PropertyChangeTest;
-
-import eu.etaxonomy.cdm.model.common.*;
+import eu.etaxonomy.cdm.model.common.CdmBaseTest;
+import eu.etaxonomy.cdm.model.common.DefinedTermBaseTest;
+import eu.etaxonomy.cdm.model.common.MarkerTypeTest;
+import eu.etaxonomy.cdm.model.common.OrderedTermBaseTest;
+import eu.etaxonomy.cdm.model.common.OrderedTermVocabularyTest;
+import eu.etaxonomy.cdm.model.common.TermVocabularyTest;
 import eu.etaxonomy.cdm.model.common.init.TermLoaderTest;
-import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBaseTest;
 import eu.etaxonomy.cdm.model.description.TextDataTest;
-import eu.etaxonomy.cdm.model.name.*;
-import eu.etaxonomy.cdm.model.taxon.*;
+import eu.etaxonomy.cdm.model.name.BotanicalNameTest;
+import eu.etaxonomy.cdm.model.taxon.TaxonTest;
 import eu.etaxonomy.cdm.strategy.cache.name.BotanicNameCacheStrategyTest;
 import eu.etaxonomy.cdm.strategy.parser.NonViralNameParserImplTest;
 
@@ -38,7 +41,7 @@ import eu.etaxonomy.cdm.strategy.parser.NonViralNameParserImplTest;
 			TermLoaderTest.class,
 			TermVocabularyTest.class,
 			//description
-			PresenceAbsenceTermBaseTest.class,
+//			PresenceAbsenceTermBaseTest.class,
 			TextDataTest.class,
 			//name
 			BotanicalNameTest.class,
@@ -46,7 +49,8 @@ import eu.etaxonomy.cdm.strategy.parser.NonViralNameParserImplTest;
 			TaxonTest.class,
 			//strategy
 			BotanicNameCacheStrategyTest.class,
-			NonViralNameParserImplTest.class
+			NonViralNameParserImplTest.class,
+			MarkerTypeTest.class
 		}
 	)
 public class CdmTestSuite {
@@ -68,7 +72,7 @@ public class CdmTestSuite {
 				TermLoaderTest.class,
 				TermVocabularyTest.class,
 				//description
-				PresenceAbsenceTermBaseTest.class,
+//				PresenceAbsenceTermBaseTest.class,
 				TextDataTest.class,
 				//name
 				BotanicalNameTest.class,
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/NameValidCharactersTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/NameValidCharactersTest.java
index 5849aa69c7..403f37f160 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/NameValidCharactersTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/NameValidCharactersTest.java
@@ -9,13 +9,10 @@
 
 package eu.etaxonomy.cdm.validation;
 
-import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertFalse;
-import static org.junit.Assert.assertNotNull;
 import static org.junit.Assert.assertTrue;
 
 import java.util.Set;
-import java.util.UUID;
 
 import javax.validation.ConstraintViolation;
 import javax.validation.Validation;
@@ -23,29 +20,14 @@ import javax.validation.Validator;
 import javax.validation.ValidatorFactory;
 import javax.validation.groups.Default;
 
-import org.junit.Assert;
-
 import org.apache.log4j.Logger;
 import org.junit.Before;
 import org.junit.Ignore;
 import org.junit.Test;
 
-import eu.etaxonomy.cdm.model.agent.AgentBase;
-import eu.etaxonomy.cdm.model.agent.Person;
-import eu.etaxonomy.cdm.model.common.Annotation;
-import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
-import eu.etaxonomy.cdm.model.common.Group;
-import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.common.User;
-import eu.etaxonomy.cdm.model.description.SpecimenDescription;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.Rank;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
-import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
-
-import eu.etaxonomy.cdm.model.reference.Reference;
-import eu.etaxonomy.cdm.model.taxon.Taxon;
 
 
 /**
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/ReferenceValidationTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/ReferenceValidationTest.java
index 525791d1be..da543b276a 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/ReferenceValidationTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/validation/ReferenceValidationTest.java
@@ -9,15 +9,12 @@
 
 package eu.etaxonomy.cdm.validation;
 
-import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertFalse;
-import static org.junit.Assert.assertNotNull;
 import static org.junit.Assert.assertTrue;
 
 import java.net.URI;
 import java.net.URISyntaxException;
 import java.util.Set;
-import java.util.UUID;
 
 import javax.validation.ConstraintViolation;
 import javax.validation.Validation;
@@ -25,32 +22,16 @@ import javax.validation.Validator;
 import javax.validation.ValidatorFactory;
 import javax.validation.groups.Default;
 
-import org.junit.Assert;
-
 import org.apache.log4j.Logger;
+import org.junit.Assert;
 import org.junit.Before;
-import org.junit.Ignore;
 import org.junit.Test;
 
-import eu.etaxonomy.cdm.model.agent.AgentBase;
-import eu.etaxonomy.cdm.model.agent.Person;
-import eu.etaxonomy.cdm.model.common.Annotation;
-import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
-import eu.etaxonomy.cdm.model.common.Group;
-import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.common.User;
-import eu.etaxonomy.cdm.model.description.SpecimenDescription;
-import eu.etaxonomy.cdm.model.name.BotanicalName;
-import eu.etaxonomy.cdm.model.name.Rank;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
-import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
-import eu.etaxonomy.cdm.model.reference.IArticle;
 import eu.etaxonomy.cdm.model.reference.IBook;
 import eu.etaxonomy.cdm.model.reference.IBookSection;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
-import eu.etaxonomy.cdm.model.taxon.Taxon;
 
 
 /**
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSource.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSource.java
index 3ab21af96c..07a3d89088 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSource.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSource.java
@@ -240,7 +240,7 @@ public class CdmDataSource extends CdmDataSourceBase {
 
 		Properties props = new Properties();
 		props.setProperty("hibernate.hbm2ddl.auto", hbm2dll.toString());
-		props.setProperty("hibernate.dialect", dbtype.getHibernateDialect());
+		props.setProperty("hibernate.dialect", dbtype.getHibernateDialectCanonicalName());
 //		OLD:props.setProperty("hibernate.cache.provider_class", cacheProviderClass.getName());
 		props.setProperty("hibernate.cache.region.factory_class", cacheProviderClass.getName());
 		props.setProperty("hibernate.show_sql", String.valueOf(showSql));
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSourceBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSourceBase.java
index a075208068..d84b22904b 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSourceBase.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmDataSourceBase.java
@@ -16,8 +16,6 @@ import java.sql.ResultSet;
 import java.sql.SQLException;
 import java.sql.Statement;
 
-import javax.sql.DataSource;
-
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.database.types.IDatabaseType;
@@ -85,25 +83,22 @@ abstract class CdmDataSourceBase implements ICdmDataSource {
 		return false;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.ICdmDataSource#getSingleValue(java.lang.String)
-	 */
 	@Override
 	public Object getSingleValue(String query) throws SQLException{
 		String queryString = query == null? "(null)": query;  
 		ResultSet resultSet = executeQuery(query);
 		if (resultSet == null || resultSet.next() == false){
-			logger.warn("No record returned for query " +  queryString);
+			logger.info("No record returned for query " +  queryString);
 			return null;
 		}
 		if (resultSet.getMetaData().getColumnCount() != 1){
-			logger.warn("More than one column selected in query" +  queryString);
-			return null;
+			logger.info("More than one column selected in query" +  queryString);
+			//first value will be taken
 		}
 		Object object = resultSet.getObject(1);
 		if (resultSet.next()){
-			logger.warn("Multiple results for query " +  queryString);
-			return null;
+			logger.info("Multiple results for query " +  queryString);
+			//first row will be taken
 		}
 		return object;
 	}
@@ -172,9 +167,9 @@ abstract class CdmDataSourceBase implements ICdmDataSource {
 	public void startTransaction() {
 		try {
 			Connection connection = getConnection();
-			connection.setAutoCommit(false);
 			this.connection = connection;
-	    	return;
+			connection.setAutoCommit(false);
+			return;
 		} catch(SQLException e) {
 			logger.error("Problems when starting transaction \n" + "Exception: " + e);
 			return;
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmPersistentDataSource.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmPersistentDataSource.java
index 04f652087d..ea3f8a6496 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmPersistentDataSource.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/CdmPersistentDataSource.java
@@ -419,7 +419,7 @@ public class CdmPersistentDataSource extends CdmDataSourceBase{
 
 		Properties props = new Properties();
 		props.setProperty("hibernate.hbm2ddl.auto", hbm2dll.toString());
-		props.setProperty("hibernate.dialect", dbtype.getHibernateDialect());
+		props.setProperty("hibernate.dialect", dbtype.getHibernateDialectCanonicalName());
 		props.setProperty("hibernate.cache.region.factory_class", cacheProviderClass.getName());
 		props.setProperty("hibernate.show_sql", String.valueOf(showSql));
 		props.setProperty("hibernate.format_sql", String.valueOf(formatSql));
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/DatabaseTypeEnum.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/DatabaseTypeEnum.java
index 90f7024699..59adfe73f4 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/DatabaseTypeEnum.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/DatabaseTypeEnum.java
@@ -15,6 +15,7 @@ import java.util.List;
 import javax.sql.DataSource;
 
 import org.apache.log4j.Logger;
+import org.hibernate.dialect.Dialect;
 
 import eu.etaxonomy.cdm.database.types.H2DatabaseType;
 import eu.etaxonomy.cdm.database.types.HSqlDbDatabaseType;
@@ -139,8 +140,8 @@ public enum DatabaseTypeEnum {
 	/**
 	 * @return
 	 */
-	public String getHibernateDialect(){
-		return dbType.getHibernateDialect();
+	public String getHibernateDialectCanonicalName(){
+		return dbType.getHibernateDialectCanonicalName();
 	}
 	   
     /**
@@ -162,8 +163,15 @@ public enum DatabaseTypeEnum {
     	logger.debug("Connection String: " + result);	
         return result;
     }
-    
-
+	
+    /**
+     * Returns the {@link Dialect hiberante dialect} used for this database type.
+	 * @return hibernate dialect
+	 */
+    public Dialect getHibernateDialect(){
+    	Dialect result = dbType.getHibernateDialect();
+    	return result;
+    }
 
 	/**
      * Returns the Name of the initialization method to be used when a hibernate datasource is created for this database
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/H2DbSupport.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/H2DbSupport.java
index 10ad3d8e41..66b1a801bd 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/H2DbSupport.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/H2DbSupport.java
@@ -1,4 +1,5 @@
 package eu.etaxonomy.cdm.database;
+
 /**
  * based on from http://code.google.com/p/java-tester/source/browse/trunk/src/main/java/org/jtester/unitils/database/H2DbSupport.java
  */
@@ -75,22 +76,22 @@ public class H2DbSupport extends DbSupport {
 
         @Override
         public void incrementSequenceToValue(String sequenceName, long newSequenceValue) {
-                getSQLHandler()
-                                .executeUpdate("alter sequence " + qualified(sequenceName) + " restart with " + newSequenceValue);
+                getSQLHandler().executeUpdate(
+                	"alter sequence " + qualified(sequenceName) + " restart with " + newSequenceValue);
         }
 
         @Override
         public void incrementIdentityColumnToValue(String tableName, String identityColumnName, long identityValue) {
                 getSQLHandler().executeUpdate(
-                                "alter table " + qualified(tableName) + " alter column " + quoted(identityColumnName)
-                                                + " RESTART WITH " + identityValue);
+                      "alter table " + qualified(tableName) + " alter column " + quoted(identityColumnName)
+                           + " RESTART WITH " + identityValue);
         }
 
         @Override
         public void disableReferentialConstraints() {
                 Set<String> tableNames = getTableNames();
                 for (String tableName : tableNames) {
-                        disableReferentialConstraints(tableName);
+                	disableReferentialConstraints(tableName);
                 }
         }
 
@@ -105,7 +106,7 @@ public class H2DbSupport extends DbSupport {
         private void disableReferentialConstraints(String tableName) {
                 Set<String> constraintNames = this.getForeignKeyConstraintNames(tableName);
                 for (String constraintName : constraintNames) {
-                        this.removeForeignKeyConstraint(tableName, constraintName);
+                	this.removeForeignKeyConstraint(tableName, constraintName);
                 }
         }
 
@@ -114,10 +115,10 @@ public class H2DbSupport extends DbSupport {
 
                 Set<String> notNullColumnNames = this.getNotNullColummnNames(tableName);
                 for (String notNullColumnName : notNullColumnNames) {
-                        if (primaryKeyColumnNames.contains(notNullColumnName)) {
-                                continue;
-                        }
-                        this.removeNotNullConstraint(tableName, notNullColumnName);
+                    if (primaryKeyColumnNames.contains(notNullColumnName)) {
+                            continue;
+                    }
+                    this.removeNotNullConstraint(tableName, notNullColumnName);
                 }
         }
 
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/ICdmDataSource.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/ICdmDataSource.java
index 099f103b5d..f5a0ded3ae 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/ICdmDataSource.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/ICdmDataSource.java
@@ -56,6 +56,7 @@ public interface ICdmDataSource {
 	public String getServer();
 
 	/**
+	 * Returns the name of the datasource on the given server.
 	 * @return
 	 */
 	public String getDatabase();
@@ -125,7 +126,9 @@ public interface ICdmDataSource {
 	public NomenclaturalCode getNomenclaturalCode();
 
 	/**
-	 * Returns a single the first value of a row of a resultset.
+	 * Returns the first value of the first row of a result set.<BR>
+	 * If no row exists in the result set
+	 * <code>null</code> is returned.
 	 * 
 	 * <strong>Caution</strong> This method opens a connection on first use. Subsequent calls will use the same connection.
 	 * Please close the connection when not needed anymore with {@link ICdmDataSource#closeOpenConnections()}
